//+------------------------------------------------------------------+
//|                                                EMA_5_6_CROSS.mq4 |
//|                                                       Codersguru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Codersguru"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue


extern int ShortEma = 5;
extern int LongEma = 6;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

static bool first_time = true;


int Crossed (double line1 , double line2)
   {
      static int last_direction = 0;
      static int current_direction = 0;
      
      //Don't work in the first load, wait for the first cross!
      if(first_time == true)
      {
         first_time = false;
         return (0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down

      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   first_time = true;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   double SEma, LEma;

   int    counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   int    pos=Bars-counted_bars;
   
   static int isCrossed  = 0;
   
//---- main calculation loop
   while(pos>=0)
     {
         
         SEma = iMA(NULL,0,ShortEma,0,MODE_EMA,PRICE_CLOSE,pos);
         LEma = iMA(NULL,0,LongEma,0,MODE_EMA,PRICE_CLOSE,pos);
   
         ExtMapBuffer1[pos]= SEma;
         ExtMapBuffer2[pos]= LEma;
         
         pos--;
     }
     
         
         SEma = iMA(NULL,0,ShortEma,0,MODE_EMA,PRICE_CLOSE,0);
         LEma = iMA(NULL,0,LongEma,0,MODE_EMA,PRICE_CLOSE,0);
         
         isCrossed = Crossed (LEma,SEma);
         string pair = Symbol();
         
         if(isCrossed == 1)
         {
            Alert( pair + ": Short EMA(" + ShortEma + ") has been crossed Long EMA(" + LongEma + ") Upward");

         }
         if(isCrossed == 2)
         {
            Alert(pair + ": Short EMA(" + ShortEma + ") has been crossed Long EMA(" + LongEma + ") Downward");

         }
         
//----

   return(0);
  }
//+------------------------------------------------------------------+